<?php

namespace App\Livewire\Studio\Catalog\Perfume;

use App\Livewire\Forms\Studio\Catalog\PerfumeForm;
use App\Models\Brand;
use App\Models\Category;
use App\Models\Outlet;
use App\Models\Perfume;
use App\Traits\Authorization\WithAuthorization;
use App\Traits\Components\WithCategorySelector;
use App\Traits\Components\WithOutletSelector;
use App\Traits\Components\WithToast;
use App\Traits\Utilities\WithUpdatedData;
use Illuminate\Contracts\View\View;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Ubah Parfum')]
class Edit extends Component
{
    use WithAuthorization, WithCategorySelector, WithOutletSelector, WithToast, WithUpdatedData;

    public PerfumeForm $form;

    public array $outlets = [];

    public array $brands = [];

    public array $categories = [];

    public function mount(Perfume $perfume): void
    {
        $this->form->setPerfume($perfume);

        $this->outlets = Outlet::pluck('name', 'id')->toArray();

        $this->brands = Brand::pluck('name', 'id')->toArray();

        $this->categories = Category::pluck('name', 'id')->toArray();
    }

    public function save(): void
    {
        $this->canOrAbort('update perfume');

        $this->form->update();

        $this->redirectRoute('studio.catalog.perfume.index', [
            'notification' => 'Parfum berhasil diperbarui.',
        ], navigate: true);
    }

    public function render(): View
    {
        return view('livewire.studio.catalog.perfume.form', [
            'pageTitle' => 'Ubah Parfum',
        ]);
    }
}
